# HTTP2

H2 is similar with WS. It also requires an underlying connection, either Plain or encrypted by TLS. The difference is that H2 does not need `Upgrade`(the h2 crate forces `http2-prior-knowledge`. And H2 supports multiplexing, allowing sending multiple requests over one connection.

Some other programs use 1 stream for read/write. However, a single stream is **NOT** full-duplex. To achieve a better performance, at least 2 streams should be used. One for read, one for write, which likes gRPC bidi-streaming.

I have attempted to use `server push`, but failed. The server could send push promises, and the client could successfully receive the pushed request's headers. The problem is that the client always blocks on resolving the pushed request's body, failing to get it's inner `RecvStream`.

So, although `server push` is provided as an option, it should always be disabled.

## position
global->endpoints->endpoint->listen|remote->trans->h2

## options

### path: string
no default value

### server_push: bool
disabled
